//
// Created by Иван_Архипов on 24.11.2017.
//

#include "Subfiles/UnknownSubFile.h"

#include "BinaryData.h"
#include "DatFile.h"
#include "SubfileData.h"
#include "EasyLogging++/easylogging++.h"

namespace LOTRO_DAT {
    UnknownSubFile::UnknownSubFile(SubFile preinit_file) : SubFile(preinit_file) {
    }

    FILE_TYPE UnknownSubFile::FileType() const {
        return UNKNOWN;
    }

    std::string UnknownSubFile::Extension() const {
        return std::string(".unknown");
    }

    SubfileData UnknownSubFile::PrepareForExport(const BinaryData &file_data) {
        if (file_data.Empty()) {
            return SubfileData();
        }

        SubfileData result;
        result.binary_data = file_data;
        result.options["fid"] = file_id();
        result.options["ext"] = Extension();
        return result;
    }

    BinaryData UnknownSubFile::MakeForImport(const BinaryData &, const SubfileData &data) {
        if (!data.options["ext"] || data.options["ext"].as<std::string>() != Extension() ||
            !data.options["fid"] || data.options["fid"].as<long long>() != file_id()) {
            LOG(ERROR) << "invalid options data!";
            return BinaryData(0);
        }
        return data.binary_data;
    }
};